package board;

import java.util.ArrayList;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.actions.MappingDispatchAction;

import comment.MemoDAO;

public class BoardAction extends MappingDispatchAction{
	public ActionForward insert(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response)throws Exception{
		BoardDAO dao = new BoardDAO();
		if(dao.insertDB((BoardBean)form)){
			return mapping.findForward("list");
		}else{
			throw new Exception("BoardAction: list()");
		}
	}
	
	public ActionForward insertReply(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response)throws Exception{
		BoardDAO dao = new BoardDAO();
		if(dao.insertReply((BoardBean)form)){
			return mapping.findForward("list");
		}else{
			throw new Exception("BoardAction: list()");
		}
	}

	public ActionForward list(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response)throws Exception{
		BoardDAO dao = new BoardDAO();
		String page = request.getParameter("page");
		if(page == null){
			page ="1";
		}
		int curPage = Integer.parseInt(page);
		
		ArrayList datas = dao.getDBList(curPage);
		request.setAttribute("datas", datas);
		request.setAttribute("pageN",dao.getPageNav(curPage));
		return mapping.findForward("success");
	}
	
	public ActionForward read(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response)throws Exception{
		BoardDAO dao = new BoardDAO();
		int b_id = Integer.parseInt(request.getParameter("b_id"));
		int b_count = Integer.parseInt(request.getParameter("b_count"));
		BoardBean board = dao.getDB(b_id);
		request.setAttribute("data", board);
		dao.countPlus(b_id, b_count);
		
		MemoDAO memo = new MemoDAO();
		ArrayList memos = memo.getDBList(b_id);
		request.setAttribute("memos",memos);
		return mapping.findForward("success");
	}
	
	public ActionForward reply(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response)throws Exception{
		BoardDAO dao = new BoardDAO();
		int b_id = Integer.parseInt(request.getParameter("b_id"));
		BoardBean board = dao.getDB_Reply(b_id);
		request.setAttribute("data", board);
		
		return mapping.findForward("success");		
	}
	
	public ActionForward delete(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response)throws Exception{
		BoardDAO dao = new BoardDAO();
		int b_id = Integer.parseInt(request.getParameter("b_id"));
		int b_step = Integer.parseInt(request.getParameter("b_step"));
		String pwd = request.getParameter("b_passwd");
		if(dao.checkPwd(b_id, pwd)){
			if(dao.deleteDB(b_id,b_step)){
				MemoDAO memo = new MemoDAO();
				if(memo.deleAll(b_id)){
					return mapping.findForward("success");
				}else{
					throw new Exception("BoardAction: memoDelete()");
				}//memo.deleAll();
			}else{
				throw new Exception("BoardAction: delete()");
			}//boardDelete();
		}else{
			return mapping.findForward("error");
		}
		
	}
	
	public ActionForward editForm(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response)throws Exception{
		BoardDAO dao = new BoardDAO();
		int b_id = Integer.parseInt(request.getParameter("b_id"));
		String pwd = request.getParameter("b_passwd");
		if(dao.checkPwd(b_id, pwd)){
			BoardBean board = new BoardBean();
			board = dao.getDB(b_id);
			request.setAttribute("data", board);
			return mapping.findForward("success");
		}else{
			return mapping.findForward("error");
		}
	}
	
	public ActionForward modify(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response)throws Exception{
		BoardDAO dao = new BoardDAO();
		if(dao.updateDB((BoardBean)form)){
			return mapping.findForward("list");
		}else{
			throw new Exception("BoardAction: update()");
		}
	}
	
	
}
