package comment;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;

public class MemoDAO {
	
	Connection conn = null;
	PreparedStatement pstmt = null;
	
	// ͺ̽  ڿ 
	String jdbc_driver = "oracle.jdbc.driver.OracleDriver";
	String jdbc_url = "jdbc:oracle:thin:@localhost:1521";
	public void connect(){
		try{
			Class.forName(jdbc_driver);
			conn = DriverManager.getConnection(jdbc_url,"sampleboard","1234");
			System.out.println("DB connection successed");
		}catch(Exception e){
			e.printStackTrace();
		}
	}
	
	void disconnect() {
		if(pstmt != null) {
			try {
				pstmt.close();
			} catch (SQLException e) {
				e.printStackTrace();
			}
		} 
		if(conn != null) {
			try {
				conn.close();
			} catch (SQLException e) {
				e.printStackTrace();
			}
		}
	}
	
	public boolean checkPwd(int c_id, String pwd){
		connect();
		
		boolean result = false;
		String sql = "select c_passwd from memo where c_id=?";
		
		try {
			pstmt = conn.prepareStatement(sql);
			pstmt.setInt(1,c_id);
			ResultSet rs = pstmt.executeQuery();
			
			rs.next();
			if(pwd.equals(rs.getString(1))) {
				result = true;
			}
			else{
				result = false;
			}
			rs.close();
		} catch (SQLException e) {
			e.printStackTrace();
		}
		finally {
			disconnect();
		}
		return result;
	}
	
	public boolean insertDB(MemoBean memo) {
		connect();
		
		String sql ="insert into memo(c_id,c_name,c_passwd,c_date,c_content,b_id) values(memo_seq.nextval,?,?,sysdate,?,?)";
		
		try {
			pstmt = conn.prepareStatement(sql);
			pstmt.setString(1,memo.getC_name());
			pstmt.setString(2,memo.getC_passwd());
			pstmt.setString(3,memo.getC_content());
			pstmt.setInt(4,memo.getB_id());
			pstmt.executeUpdate();
		} catch (Exception e) {
			e.printStackTrace();
			return false;
		}
		finally {
			disconnect();
		}
		return true;
	}
	
	public boolean deleAll(int b_id) {
		connect();
		
		String sql ="delete from memo where b_id=?";
		
		try {
			pstmt = conn.prepareStatement(sql);
			pstmt.setInt(1,b_id);
			pstmt.executeUpdate();
		} catch (SQLException e) {
			e.printStackTrace();
			return false;
		}
		finally {
			disconnect();
		}
		return true;
	}
	
	public boolean deleteDB(int c_id) {
		connect();
		
		String sql ="delete from memo where c_id=?";
		
		try {
			pstmt = conn.prepareStatement(sql);
			pstmt.setInt(1,c_id);
			pstmt.executeUpdate();
			
		} catch (SQLException e) {
			e.printStackTrace();
			return false;
		}
		finally {
			disconnect();
		}
		return true;
	}
	
	public ArrayList getDBList(int b_id) {
		connect();
		ArrayList<MemoBean> datas = new ArrayList<MemoBean>();
		
		String sql = "select * from memo where b_id=? order by c_id asc";
		try {
			pstmt = conn.prepareStatement(sql);
			pstmt.setInt(1,b_id);
			
			ResultSet rs = pstmt.executeQuery();
			while(rs.next()) {
				MemoBean memo = new MemoBean();
				
				memo.setC_id(rs.getInt("c_id"));
				memo.setC_name(rs.getString("c_name"));
				memo.setC_date(rs.getDate("c_date"));
				memo.setC_content(rs.getString("c_content"));
				datas.add(memo);
			}
			rs.close();			
		} catch (SQLException e) {
			e.printStackTrace();
		}
		finally {
			disconnect();
		}
		return datas;
	}

}
